package com.jasamedika.medifirst2000.service.impl;

import java.util.HashMap;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.jasamedika.medifirst2000.converter.BaseConverterImpl;
import com.jasamedika.medifirst2000.dao.RiwayatPerkembanganPsikomotorDao;
import com.jasamedika.medifirst2000.entities.AntrianPasienDiPeriksa;
import com.jasamedika.medifirst2000.entities.Kelahiran;
import com.jasamedika.medifirst2000.entities.PasienDaftar;
import com.jasamedika.medifirst2000.entities.ProsesKelahiran;
import com.jasamedika.medifirst2000.entities.RiwayatPerkembanganPsikomotor;
import com.jasamedika.medifirst2000.entities.StatusYaTidak;
import com.jasamedika.medifirst2000.service.RiwayatPerkembanganPsikomotorService;
import com.jasamedika.medifirst2000.util.CommonUtil;
import com.jasamedika.medifirst2000.vo.AntrianPasienDiPeriksaVO;
import com.jasamedika.medifirst2000.vo.KelahiranVO;
import com.jasamedika.medifirst2000.vo.PasienDaftarVO;
import com.jasamedika.medifirst2000.vo.RiwayatPerkembanganPsikomotorVO;

/**
 * @author Teguh
 */

@Service("RiwayatPerkembanganPsikomotorService")
public class RiwayatPerkembanganPsikomotorServiceImpl implements RiwayatPerkembanganPsikomotorService {

	@Autowired
	private RiwayatPerkembanganPsikomotorDao riwayatPerkembanganPsikomotorDao;
	
	@Autowired
	private BaseConverterImpl<RiwayatPerkembanganPsikomotorVO,RiwayatPerkembanganPsikomotor> riwayatPerkembanganPsikomotorConverter;
	
	@Autowired
	private BaseConverterImpl<AntrianPasienDiPeriksaVO,AntrianPasienDiPeriksa> pasienDaftarConverter;
	
	@Override
	public Map<String,Object> addRiwayatPerkembanganPskomotor(RiwayatPerkembanganPsikomotorVO vo) {

		RiwayatPerkembanganPsikomotor riwayatPerkembanganPsikomotor=new RiwayatPerkembanganPsikomotor();
				
		if(CommonUtil.isNotNullOrEmpty(vo)){
			riwayatPerkembanganPsikomotor=riwayatPerkembanganPsikomotorConverter.transferVOToModel(vo, new RiwayatPerkembanganPsikomotor());
		}
		if(CommonUtil.isNotNullOrEmpty(vo.getPasienDaftar())){
			riwayatPerkembanganPsikomotor.setPasien(pasienDaftarConverter.transferVOToModel(vo.getPasienDaftar(), new AntrianPasienDiPeriksa()));
		}

		RiwayatPerkembanganPsikomotor riwayatPerkembanganPsikomotorResult=riwayatPerkembanganPsikomotorDao.save(riwayatPerkembanganPsikomotor);
		
		Map<String,Object> result=new HashMap<String,Object>();
		
		if (CommonUtil.isNotNullOrEmpty(riwayatPerkembanganPsikomotorResult)) {
			result.put("noRec", riwayatPerkembanganPsikomotorResult.getNoRec());
		}
		
		return result;
		
	}
	
	@Override
	public Map<String,Object> updateRiwayatPerkembanganPskomotor(RiwayatPerkembanganPsikomotorVO vo) {

		RiwayatPerkembanganPsikomotor riwayatPerkembanganPsikomotor=new RiwayatPerkembanganPsikomotor();
				
		if(CommonUtil.isNotNullOrEmpty(vo)){
			riwayatPerkembanganPsikomotor=riwayatPerkembanganPsikomotorConverter.transferVOToModel(vo, new RiwayatPerkembanganPsikomotor());
		}

		RiwayatPerkembanganPsikomotor riwayatPerkembanganPsikomotorResult=riwayatPerkembanganPsikomotorDao.save(riwayatPerkembanganPsikomotor);
		
		Map<String,Object> result=new HashMap<String,Object>();
		
		if (CommonUtil.isNotNullOrEmpty(riwayatPerkembanganPsikomotorResult)) {
			result.put("noRec", riwayatPerkembanganPsikomotorResult.getNoRec());
		}
		
		return result;
		
	}
	
}
